/**
 * 提交按钮封装
 * 需要传入以下参数
 * form控件
 * appId 事务Id
 * draftId 草稿Id 可不传
 * callback 保存成功后执行函数
 */
import React, { Component } from 'react';
import { Button } from 'antd';
import AddModel from './AddModal';
import {preHandle} from '../../utils/myutils';
import { connect } from 'dva';
import { openToast } from '../../location/Notification';
@connect()
export default class idnex extends Component {
    constructor(props){
        super(props)
        this.state = {
            visible: false,
            isLoading: false
        }
    }
    showModal = () => {
        this.props.form.validateFields((err, values) => {
            if (!err) {
                this.setState({
                    visible: true,
                });
            }
        });
    }
    handleOk = () => {
        let {dispatch} = this.props;
        this.props.form.validateFields((err, values) => {
            if (!err) {
                preHandle(values); // 引入 import preHandle from '@/webPublic/one_stop_public/utils/myutils.js'
                console.log(values)
                this.setState({
                    isLoading: true,
                },() => {
                    dispatch({
                        type: 'affair/startProcess',
                        payload: {
                            content: JSON.stringify(values), // 表单数据
                            appId: this.props.appId, // 这里应该由上级路由跳转传入 事务Id
                            id: !!this.props.draftId ? this.props.draftId : null // 确认是否存在草稿表单Id存在即传入
                        },
                        callback: val => {
                            if (val) {
                                if(this.props?.callback){
                                    this.props.callback()
                                }
                            } else {
                                openToast('error', '保存失败', '请尝试');
                            }
                        },
                    }).then(()=>{
                        this.setState({
                            isLoading: false,
                            visible: false,
                        })
                    })
                })
            } else {
                openToast('error', '提交失败', '请填写必填项');
            }
        });
    }
    handleCancel = () => {
        this.setState({
            visible: false
        })
    }
    render() {
        const {
            text
        } = this.props
        const {
            visible,
            isLoading,
        } = this.state
        return (
            <>
            <Button
                onClick={this.showModal}
                isLoading={isLoading}
                type='primary'
                >
                {
                    text??'提交'
                }
            </Button>
            <AddModel 
                visible={visible}
                handleOk={this.handleOk}
                isLoading={isLoading}
                handleCancel={this.handleCancel}
                />
            </>
        )
    }
}
